using Application.Services.Database;
using FluentValidation;

namespace Application.Endpoints.Pacients.Login;

public class PacientLoginValidation : AbstractValidator<PacientLoginDTO>
{
    private readonly IPacientRepository _pacientRepository;

    public PacientLoginValidation(IPacientRepository pacientRepository)
    {
        _pacientRepository = pacientRepository;

        RuleFor(x => x.Email)
            .NotEmpty().WithMessage("Email is required.")
            .EmailAddress().WithMessage("Invalid email format.")
            .MustAsync(BeExistingPacient).WithMessage("Pacient with this email does not exist.");

        RuleFor(x => x.Password)
            .NotEmpty().WithMessage("Password is required.")
            .MinimumLength(8).WithMessage("Password must be at least 8 characters long.");
    }

    private async Task<bool> BeExistingPacient(string email, CancellationToken cancellationToken)
    {
        var pacient = await _pacientRepository.FindByEmailAsync(email);
        return pacient != null;
    }
}
